package com.dji.sdk.common;


import org.springframework.stereotype.Component;

import java.text.DecimalFormat;

/**
 * @author hqjiang
 * @version 1.0
 * @date 2024/7/2
 */

@Component
public class CoordinateUtil {
    private static final String GAODE_API_URL = "https://restapi.amap.com/v3/assistant/coordinate/convert?locations=经度,纬度&coordsys=gps&key=96d7df07675b274a4078b107e56b2a4a";// + AMapProperties.key;

    public static void main(String[] args) {

//        {121.59529228016724, 31.2771648028396},
//        {121.55949257988347, 31.27563389661576},
//        {121.55866186357967, 31.27687211836336}
        double lon = 121.55866186357967;
        double lat = 31.27687211836336;
//        log.info("GPS转高德之前：" + lon + "," + lat);
//        AMap aMap = CoordinateUtil.convertToAMapCoord(lon,lat);
//        log.info("GPS转高德之后（WEBAPI)：" + aMap.getLongitude() + "," + aMap.getLatitude());
        AMap aMap = transform(lon,lat);
        //log.info("GPS转高德之后：" + aMap.getLongitude() + "," + aMap.getLatitude());
        /**
         * 高德API（https://lbs.amap.com/api/webservice/guide/api/convert）经纬度转换之后.
         * 两者误差不是很大
         */
    }

//    public static AMap convertToAMapCoord(double originalLng, double originalLat) {
//        String response = sendRequest(originalLng,originalLat);
//        log.info("GPS转高德之后（WEBAPI)：" + response);
//        JsonElement element = JsonParser.parseString(response);
//        String status = element.getAsJsonObject().get("status").getAsString();
//        if("1".equals(status)) {
//            String locations = element.getAsJsonObject().get("locations").getAsString();
//            String[] locArray =  locations.split(",");
//            double lon = Double.parseDouble(String.format("%.5f", Double.parseDouble(locArray[0])));
//            double lat = Double.parseDouble(String.format("%.5f", Double.parseDouble(locArray[1])));
//            return new AMap(lon, lat);
//        }
//
//        return null;
//
//    }

//    private static String sendRequest(double longitude, double latitude) {
//        HttpGet request = new HttpGet(GAODE_API_URL
//                .replace("经度", Double.toString(longitude))
//                .replace("纬度", Double.toString(latitude)));
//
//        try {
//            org.apache.http.client.HttpClient client = HttpClients.createDefault();
//            HttpResponse httpResponse = client.execute(request);
//            return EntityUtils.toString(httpResponse.getEntity(), "UTF-8");
//        } catch (Exception e) {
//            e.printStackTrace();
//            return null;
//        }
//    }

    /**
     * 椭球参数
     */
    private static double pi = 3.14159265358979324;
    /**
     * 卫星椭球坐标投影到平面地图坐标系的投影因子
     */
    private static double a = 6378245.0;
    /**
     * 椭球的偏心率
     */
    private static double ee = 0.00669342162296594323;

    public static double checkValidVal(double value) {
        String logStr = String.valueOf(value);
        if(logStr.indexOf("E") > 0) {
           return 0d;
        }
        return value;
    }

    /**
     * 经纬度 GPS转高德
     *
     * @param wgLon GPS经度
     * @param wgLat GPS维度
     * @return 转化后的经纬度坐标
     */
    public static AMap transform(double wgLon, double wgLat) {
        wgLon = checkValidVal(wgLon);
        wgLat = checkValidVal(wgLat);

        if (outOfChina(wgLat, wgLon)) {
            return new AMap(wgLon, wgLat);
        }

        double dLat = transformLat(wgLon - 105.0, wgLat - 35.0);
        double dLon = transformLon(wgLon - 105.0, wgLat - 35.0);
        double radLat = wgLat / 180.0 * pi;
        double magic = Math.sin(radLat);
        magic = 1 - ee * magic * magic;
        double sqrtMagic = Math.sqrt(magic);
        dLat = (dLat * 180.0) / ((a * (1 - ee)) / (magic * sqrtMagic) * pi);
        dLon = (dLon * 180.0) / (a / sqrtMagic * Math.cos(radLat) * pi);
        double transLat = wgLat + dLat;
        double transLon = wgLon + dLon;

//        DecimalFormat df = new DecimalFormat("#.000000");
//        transLon = Double.parseDouble(df.format(transLon));
//        transLat = Double.parseDouble(df.format(transLat));


        return new AMap(transLon, transLat);
    }

    private boolean isTooLong(double value) {
        return String.valueOf(value).indexOf("E") > 0;
    }

    /**
     * 判断是否为国外坐标，，不在国内不做偏移
     *
     * @param lat
     * @param lon
     * @return
     */
    private static Boolean outOfChina(double lat, double lon) {
        if (lon < 72.004 || lon > 137.8347)
            return true;
        if (lat < 0.8293 || lat > 55.8271)
            return true;
        return false;
    }

    /**
     * 纬度转换
     *
     * @param x
     * @param y
     * @return
     */
    private static double transformLat(double x, double y) {
        double ret = -100.0 + 2.0 * x + 3.0 * y + 0.2 * y * y + 0.1 * x * y + 0.2 * Math.sqrt(Math.abs(x));
        ret += (20.0 * Math.sin(6.0 * x * pi) + 20.0 * Math.sin(2.0 * x * pi)) * 2.0 / 3.0;
        ret += (20.0 * Math.sin(y * pi) + 40.0 * Math.sin(y / 3.0 * pi)) * 2.0 / 3.0;
        ret += (160.0 * Math.sin(y / 12.0 * pi) + 320 * Math.sin(y * pi / 30.0)) * 2.0 / 3.0;
        return ret;
    }

    /**
     * 经度转换
     *
     * @param x
     * @param y
     * @return
     */
    private static double transformLon(double x, double y) {
        double ret = 300.0 + x + 2.0 * y + 0.1 * x * x + 0.1 * x * y + 0.1 * Math.sqrt(Math.abs(x));
        ret += (20.0 * Math.sin(6.0 * x * pi) + 20.0 * Math.sin(2.0 * x * pi)) * 2.0 / 3.0;
        ret += (20.0 * Math.sin(x * pi) + 40.0 * Math.sin(x / 3.0 * pi)) * 2.0 / 3.0;
        ret += (150.0 * Math.sin(x / 12.0 * pi) + 300.0 * Math.sin(x / 30.0 * pi)) * 2.0 / 3.0;
        return ret;
    }
}
